## libmurmurhash 1.3

=== Makefile ===

CPPFLAGS+=-Wall -Wextra -Wno-implicit-fallthrough
CFLAGS+=-ggdb -O2 -fPIC
SHELL=bash


VERSION=1.3
SOVERSION=1
PROJECT_VERSION=libmurmurhash-$(VERSION)
TARBALL=$(PROJECT_VERSION).tar.gz

DESTDIR?=/usr
LIBDIR?=$(DESTDIR)/lib
INCLUDEDIR?=$(DESTDIR)/include
MANDIR?=$(DESTDIR)/share/man
INSTALL?=install

SONAME=libmurmurhash.so.$(SOVERSION)
OBJECTS=PMurHash.o murmurhash.o

.DEFAULT: all
.PHONY: all clean check format
all: libmurmurhash.a $(SONAME) mmh

## build the library
PMurHash.o: PMurHash.c PMurHash.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ PMurHash.c

murmurhash.o: murmurhash.c murmurhash.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c -o $@ murmurhash.c

libmurmurhash.a: $(OBJECTS)
	$(AR) -qs $@ $^

$(SONAME): libmurmurhash.a
	$(CC) -Wl,-soname,$(SONAME) -shared -o $@ -Wl,--whole-archive -L. -lmurmurhash -Wl,--no-whole-archive

## installation
.PHONY: install install-dev install-lib uninstall dist distcheck

install: install-dev install-lib

install-dev:
	$(INSTALL) -D -m0644 -t "$(INCLUDEDIR)" murmurhash.h
	$(INSTALL) -D -m0644 -t "$(MANDIR)/man3" murmurhash.3
	ln -f -r -s "$(MANDIR)/man3/murmurhash.3" "$(MANDIR)/man3/MurmurHash3_x86_32.3"
	ln -f -r -s "$(MANDIR)/man3/murmurhash.3" "$(MANDIR)/man3/MurmurHash3_x86_128.3"
	ln -f -r -s "$(MANDIR)/man3/murmurhash.3" "$(MANDIR)/man3/MurmurHash3_x64_128.3"
	ln -f -r -s "$(MANDIR)/man3/murmurhash.3" "$(MANDIR)/man3/lmmh_x86_32.3"
	ln -f -r -s "$(MANDIR)/man3/murmurhash.3" "$(MANDIR)/man3/lmmh_x86_128.3"
	ln -f -r -s "$(MANDIR)/man3/murmurhash.3" "$(MANDIR)/man3/lmmh_x64_128.3"

install-lib: $(SONAME)
	$(INSTALL) -D -t "$(LIBDIR)" $(SONAME)
	ln -f -r -s "$(LIBDIR)/$(SONAME)" "$(LIBDIR)/libmurmurhash.so"

uninstall:
	$(RM) "$(INCLUDEDIR)/murmurhash.h"
	$(RM) "$(LIBDIR)/libmurmurhash.so"
	$(RM) "$(LIBDIR)/$(SONAME)"
	$(RM) "$(MANDIR)/man3/murmurhash.3"
	$(RM) "$(MANDIR)/man3/MurmurHash3_*"
	$(RM) "$(MANDIR)/man3/lmmh_*"

$(TARBALL):
	mkdir -p "$(PROJECT_VERSION)"/test
	cp Makefile Readme.md NOLICENSE "$(PROJECT_VERSION)"
	cp *.h *.c "$(PROJECT_VERSION)"
	cp test/*.c test/*.h "$(PROJECT_VERSION)/test"
	cp test/almostempty test/almostempty.hash "$(PROJECT_VERSION)/test"
	cp murmurhash.3 "$(PROJECT_VERSION)"
	tar -ca -f $@ "$(PROJECT_VERSION)"
	$(RM) -r "$(PROJECT_VERSION)"

dist: $(TARBALL)

distcheck: dist
	tar -xzvf "$(TARBALL)"
	$(MAKE) -C "$(PROJECT_VERSION)"
	$(MAKE) -C "$(PROJECT_VERSION)" check
	$(RM) -r "$(PROJECT_VERSION)"

## checks
mmh.o: test/mmh.c
	$(CC) -I. $(CPPFLAGS) $(CFLAGS) -c -o $@ $^

mmh_old.o: test/mmh_old.c
	$(CC) -I. $(CPPFLAGS) $(CFLAGS) -c -o $@ $^

MurmurHash3.o: test/MurmurHash3.c test/MurmurHash3.h
	$(CC) -I. $(CPPFLAGS) $(CFLAGS) -c -o $@ test/MurmurHash3.c

# new interface, static linking
mmh: mmh.o libmurmurhash.a
	$(CC) $(CFLAGS) -o $@ $^ -L. -lmurmurhash

# new interface, dynamic linking
mmh_dyn: test/mmh.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ $^ -lmurmurhash

# old interface, static linking
mmh_old: mmh_old.o libmurmurhash.a
	$(CC) $(CFLAGS) -o $@ $^ -L. -lmurmurhash

# old interface, reference implementation
mmh_ref: mmh_old.o MurmurHash3.o
	$(CC) $(CFLAGS) -o $@ $^

check: mmh mmh_old
	diff test/almostempty.hash <(./mmh test/almostempty)
	diff test/almostempty.hash <(./mmh_old test/almostempty)

# Will fail on all but (64bit) little endian systems
check-reference: mmh_ref
	diff test/almostempty.hash <(./mmh_ref test/almostempty)

# should be checked after installation!
check-dynamic: mmh_dyn
	diff test/almostempty.hash <(./mmh_dyn test/almostempty)


## misc

format:
	clang-format -i *.c *.h test/*.c test/*.h

clean:
	$(RM) *.o *.a *.so *.so.* mmh mmh_*
	$(RM) test/*.o *.tar.gz
	$(RM) -r "$(PROJECT_VERSION)"

=== debian/changelog ===
libmurmurhash (1.3-2) unstable; urgency=medium

  * deactivate broken test.

 -- Fabian Klötzl <kloetzl@evolbio.mpg.de>  Tue, 12 Feb 2019 08:04:29 +0000

libmurmurhash (1.3-1) unstable; urgency=medium

  * Team upload.
  * d/libmumumhash-dev.links: add more manpages

 -- Fabian Klötzl <kloetzl@evolbio.mpg.de>  Mon, 11 Feb 2019 13:15:45 +0000

libmurmurhash (1.2-2) unstable; urgency=medium

  * Team upload.
  * Test-Depends: build-essential
  * Provide symbols file for libmurmurhash1

 -- Andreas Tille <tille@debian.org>  Fri, 08 Feb 2019 18:16:34 +0100

libmurmurhash (1.1-1) unstable; urgency=medium

  * Initial release (Closes: #921353)

 -- Fabian Klötzl <kloetzl@evolbio.mpg.de>  Fri, 01 Feb 2019 11:04:29 +0000

=== debian/control ===
Source: libmurmurhash
Section: libs
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Fabian Klötzl <kloetzl@evolbio.mpg.de>
Build-Depends: debhelper (>= 12~),
               d-shlibs
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/libmurmurhash
Vcs-Git: https://salsa.debian.org/med-team/libmurmurhash.git
Homepage: https://github.com/kloetzl/libmurmurhash

Package: libmurmurhash1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Portable MurmurHash Implementation
 MurmurHash is one of the most commonly used non-cryptographic hash
 functions. This project bundles it into a shared library to avoid code
 duplication. Further it provides compatibility even for big-endian
 systems.
 .
 This package installs shared library files.


Package: libmurmurhash-dev
Architecture: any
Section: libdevel
Depends: libmurmurhash1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: libmurmurhash header files
 MurmurHash is one of the most commonly used non-cryptographic hash
 functions. This project bundles it into a shared library to avoid code
 duplication. Further it provides compatibility even for big-endian
 systems.
 .
 This package installs files needed for development.

## libmurmurhash 1.5

=== debian/changelog ===
libmurmurhash (1.5-3) unstable; urgency=medium

  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Keep dh_missing happy by using installed manpage
  * Remove useless .la file to keep dh_missing happy

 -- Andreas Tille <tille@debian.org>  Sun, 22 Aug 2021 09:22:44 +0200

libmurmurhash (1.5-2) unstable; urgency=medium

  [ Matthias Klose ]
  * Team upload.
  * Fix linking of autopkg tests with ld --as-needed.
    Closes: #936088

  [ Andreas Tille ]
  * debhelper-compat 12
  * Standards-Version: 4.4.0
  * Remove trailing whitespace in debian/changelog

 -- Andreas Tille <tille@debian.org>  Fri, 30 Aug 2019 08:09:00 +0200

libmurmurhash (1.5-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Mark the binary packages as Multi-Arch: same

  [ Fabian Klötzl ]
  * Update to upstream version 1.5
    This also includes a SONAME bump to 2

  [ Andreas Tille ]
  * Fix autopkgtest

 -- Fabian Klötzl <kloetzl@evolbio.mpg.de>  Tue, 09 Jul 2019 22:09:14 +0200

=== debian/control ===
Source: libmurmurhash
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Fabian Klötzl <kloetzl@evolbio.mpg.de>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/libmurmurhash
Vcs-Git: https://salsa.debian.org/med-team/libmurmurhash.git
Homepage: https://github.com/kloetzl/libmurmurhash
Rules-Requires-Root: no

Package: libmurmurhash2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Portable MurmurHash Implementation
 MurmurHash is one of the most commonly used non-cryptographic hash
 functions. This project bundles it into a shared library to avoid code
 duplication. Further it provides compatibility even for big-endian
 systems.
 .
 This package installs shared library files.

Package: libmurmurhash-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libmurmurhash2 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: libmurmurhash header files
 MurmurHash is one of the most commonly used non-cryptographic hash
 functions. This project bundles it into a shared library to avoid code
 duplication. Further it provides compatibility even for big-endian
 systems.
 .
 This package installs files needed for development.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include usr \
		    --movedev "debian/tmp/usr/lib/*/pkgconfig/*.pc" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		    debian/tmp/usr/lib/*/*.so
	find debian -name "lib*.la" -delete

=== debian/watch ===
# alternatively to this template you might like to try
#   https://github.com/FedericoCeratto/debian-package-init/blob/master/deb_create_watch.py

version=4

# Uncomment to find new files on Github
#  - when using releases:
https://github.com/kloetzl/libmurmurhash/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
# Remark: frequently you can do s/#PREFIX#/v?/ since 'v' or nothing is quite common but there are other prefixes possible

## libmurmurhash 1.6

=== debian/changelog ===
libmurmurhash (1.6-1) unstable; urgency=medium

  * Add myself to Uploaders
    Closes: #1059715
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  Remove field Section on binary package libmurmurhash2 that duplicates source.

 -- Andreas Tille <tille@debian.org>  Tue, 06 Feb 2024 09:01:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: libmurmurhash
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Fabian Klötzl <kloetzl@evolbio.mpg.de>
+Uploaders: Fabian Klötzl <kloetzl@evolbio.mpg.de>,
+           Andreas Tille <tille@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                d-shlibs
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libmurmurhash
 Vcs-Git: https://salsa.debian.org/med-team/libmurmurhash.git
 Homepage: https://github.com/kloetzl/libmurmurhash
@@ -14,7 +15,6 @@
 Package: libmurmurhash2
 Architecture: any
 Multi-Arch: same
-Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
 Description: Portable MurmurHash Implementation
